using System;
using System.Text.Json.Serialization;
namespace org.accordproject.templatemark {
   using org.accordproject.commonmark;
   using concerto.metamodel;
   using concerto;
   abstract class ElementDefinition : Child {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ElementDefinition";
      public string name { get; set; }
      public string elementType { get; set; }
      public Decorator[] decorators { get; set; }
   }
   class VariableDefinition : ElementDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.VariableDefinition";
      public string identifiedBy { get; set; }
   }
   class FormattedVariableDefinition : VariableDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.FormattedVariableDefinition";
      public string format { get; set; }
   }
   class EnumVariableDefinition : VariableDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.EnumVariableDefinition";
      public string[] enumValues { get; set; }
   }
   class FormulaDefinition : ElementDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.FormulaDefinition";
      public string[] dependencies { get; set; }
      public string code { get; set; }
   }
   abstract class BlockDefinition : ElementDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.BlockDefinition";
   }
   class ClauseDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ClauseDefinition";
   }
   class ContractDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ContractDefinition";
   }
   class WithDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.WithDefinition";
   }
   class ConditionalDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ConditionalDefinition";
      public Child[] whenTrue { get; set; }
      public Child[] whenFalse { get; set; }
   }
   class OptionalDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.OptionalDefinition";
      public Child[] whenSome { get; set; }
      public Child[] whenNone { get; set; }
   }
   class JoinDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.JoinDefinition";
      public string separator { get; set; }
   }
   class ListBlockDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ListBlockDefinition";
      public string type { get; set; }
      public string tight { get; set; }
      public string start { get; set; }
      public string delimiter { get; set; }
   }
   class ForeachBlockDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ForeachBlockDefinition";
   }
   class WithBlockDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.WithBlockDefinition";
   }
   class ConditionalBlockDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.ConditionalBlockDefinition";
      public Child[] whenTrue { get; set; }
      public Child[] whenFalse { get; set; }
   }
   class OptionalBlockDefinition : BlockDefinition {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.templatemark.OptionalBlockDefinition";
      public Child[] whenSome { get; set; }
      public Child[] whenNone { get; set; }
   }
}
